#include <stdio.h>
#include <dir.h>
#include <dos.h>
#include <string.h>

int counter=0;
char thismask[255];
char thisentry[255];

void processDir(const char *curdir, const char *mask)
{
	struct ffblk ffblk;
	int done;

	sprintf(thismask,"%s\\%s",curdir,mask);

	done=findfirst(thismask,&ffblk,FA_DIREC);
	while (!done)
	{
		sprintf(thisentry,"%s\\%s",curdir,ffblk.ff_name);
		printf("Deleting %s ... ",thisentry);
		if(remove(thisentry)==0)
		{
			printf("OK\n");
			counter++;
		}
		else
			printf("could not delete file !!!\n");

		done=findnext(&ffblk);
	}
}

void getSubdirs(const char *curdir,const char *mask)
{
	struct ffblk ffblk;
	int done;

	processDir(curdir,mask);

	char *thispath=new char[255];

	sprintf(thismask,"%s\\*.*",curdir);

	done=findfirst(thismask,&ffblk,FA_DIREC);
	while (!done)
	{
		if((strcmp(ffblk.ff_name,".")!=0)&&(strcmp(ffblk.ff_name,"..")!=0)
			&&(ffblk.ff_attrib==FA_DIREC))
		{
			sprintf(thispath,"%s\\%s", curdir,ffblk.ff_name);
			getSubdirs(thispath,mask);

		}
		done = findnext(&ffblk);
	}
	delete[] thispath;
}

int main(int argc, char * argv[])
{
	char *where = ".";
	char *mask;

	printf("CLEANUP: recursive selective file cleanup utility (c) 1995 Thomas Schimming\n");

	switch(argc)
	{
		case 2:	mask		= argv[1];
					break;

		case 3:	where		= argv[1];
					mask		= argv[2];
					break;

		default: printf("Usage: cleanup [PathSpec] FilterExpr (e.g. cleanup E:\\TEMP *.bak)\n");
					return 1;
	}

	if(strlen(where)==3)
		if(where[1]==':')
			if(where[2]=='\\')
				where[2]=0;

	getSubdirs(where,mask);

	if(counter)
		printf("%i files deleted.\n",counter);
	else
		printf("no files found.\n");

	return 0;
}
